#include <iostream>
# include "onedimensionnewton.h"
class F1Problem :public Problem
{
public:
    F1Problem();
    virtual double funmin(Data &x);
    virtual Data gradient(Data &x);
};

F1Problem::F1Problem()
    :Problem(1)
{
        left.resize(1);
        right.resize(1);
        left[0]=0;
        right[0]=10;
}

double  F1Problem::funmin(Data &x)
{
    return x[0]*x[0]/2.0-0.8*x[0]+0.2*cos(x[0]);
}

Data    F1Problem::gradient(Data &x)
{
    Data g;
    g.resize(1);
    g[0]=x[0]-0.8-0.2*sin(x[0]);
    return g;
}

int main()
{
    F1Problem p;
    OneDimensionNewton method(&p);
    method.Solve();
    return 0;
}
